#!/usr/bin/perl
# $Id: Book.pm,v 1.4 2003/01/25 05:52:27 jim Exp $

package U6::Book;
BEGIN {
	use Exporter;
	our ($VERSION, @ISA, @EXPORT, @EXPORT_OK);
	$VERSION = do { my @r = (q$Revision: 1.4 $ =~ /\d+/g); sprintf "%d."."%02d" x $#r, @r };
	@ISA = qw(Exporter);
	@EXPORT    = qw();
	@EXPORT_OK = qw(@books);
}

use strict;

# exports
our @books;

my $buf;
my @offsets;

sub init {
	open(BOOK, "files/book.dat") or die "$!";
	# Format: 128 shorts - offsets into file
	# Then null-terminated ASCII strings, one for each book.
	read BOOK, $buf, 256;
	# @offsets = unpack "v*", $buf;

	read BOOK, $buf, (-s BOOK) - 256;

	# A bit inefficient, but recommended by perlpacktut (and simple!)
	# File offsets in @offsets are currently ignored.
	# There should technically be exactly 128 (129?) books.
	my $num_books = $buf =~ tr/\0// - 1;
	@books = unpack "Z*" x $num_books, $buf;

	return 1;
}

close(BOOK);

1;
