#!/usr/bin/perl -w
# $Id: Look.pm,v 1.6 2003/02/12 00:04:08 jim Exp $

package U6::Look;
BEGIN {
	use Exporter;
	our ($VERSION, @ISA, @EXPORT, @EXPORT_OK);
	$VERSION = do { my @r = (q$Revision: 1.6 $ =~ /\d+/g); sprintf "%d."."%02d" x $#r, @r };
	@ISA = qw(Exporter);
	@EXPORT    = qw();
	@EXPORT_OK = qw(%look get_obj_name);
}

use strict;
use Data::Dumper;

our %look;

my $file = "uncompressed/look.lzd";

sub init {
	local $/;
	open LOOK, $file or die "$!";
	my $buf = <LOOK>;
	# Create a hash with key S (short, tile number) and value Z (asciiz string, object name)
	%look = unpack "(S Z*)*", substr($buf, 0, -2);  # chop final two chars (short) off
	close LOOK;
}

# Search for object name, given a tile number.  Look data that is identical
# for a series of tiles is linked to the last tile number of the series.
sub get_obj_name {
	my $num = shift;
	# About as far from a binary search as you can get.
	# This should not be hardcoded.
	while ($num <= 0x800) {   # Note: there's an object (sentinel?) at 2048.
		return $look{$num} if defined $look{$num};
		$num++;
	}
	return undef;
}

1;
