#!/usr/bin/perl -w
# $Id: look.pl,v 1.2 2003/01/25 06:46:50 jim Exp $

use strict;
use Data::Dumper;
use U6::Look qw(%look get_obj_name);

U6::Look::init();

# If numeric (dec, hex, oct) arguments are given, 
# print out object name for each.  We accept a tile number,
# not just an exact key contained in %look.
if (@ARGV) {
	for my $obj (@ARGV) {
		$obj = oct($obj) if $obj =~ /^0/;
		my $name = get_obj_name($obj);
		warn("invalid object $obj\n"), next if not defined $name;
		printf "%04d (0x%04x) %s\n", $obj, $obj, $name;
	}
	exit;
}

# Otherwise, no arguments: print object name for every key in look.
# There will be holes, since that's how %look is organized.
for (sort { $a <=> $b } keys %look) {
 	printf "%04d (0x%04x) %s\n", $_, $_, $look{$_};
}
