#!/usr/bin/perl -w
# $Id: obj.pl,v 1.3 2003/02/12 13:29:32 jim Exp $

use strict;
use U6::Obj qw(@objblk print_obj_info);

die "usage: $0 objblk_num ...\n" unless @ARGV;

U6::Obj::init();
U6::Look::init();  # For print_obj_info, Look needs to be initialized.

for my $blk (@ARGV) {
	$blk = U6::Obj::block_id_to_num($blk) if $blk =~ /^[a-h]/;
	$blk = oct($blk) if $blk =~ /^0/;
	warn("error: block number $blk out of range 0 - $#objblk\n"), next if $blk > $#objblk;
	printf "\n*** block $blk (%s)\n----\n", U6::Obj::block_num_to_id($blk);  # header
	for my $obj (@{ $objblk[$blk] }) {
		#	print " -- spawns:\n" if $last_object_was_egg;
		info($obj);
		print "---\n"; # unless is_egg(%$obj);
	}
}

sub info {
	my $obj = shift;
	my $depth = shift || 0;

	print_obj_info(%$obj);
	for (@ {$obj->{contains}}) {
		print "--- depth ", $depth + 1, "\n";
		info($_, $depth + 1);
	}
}
